#include <stdio.h>
#include <string.h>

#include "aniDoc.h"

#include "glView.h"

CAniDoc::CAniDoc()
{
	m_pScene=NULL;
}


CAniDoc::~CAniDoc()
{
	if (m_pScene)
		delete m_pScene;
}

bool CAniDoc::loadObject(char *objname)
{
	Object* obj=new Object(objname);

	if (!(obj->isLoaded())) {
		delete obj;
		return false;
	}

	Scene *scene = new Scene(obj);
	scene->setDocument(this);

	scene->createView();
	scene->createObjList();

	m_pScene = scene;

	return true;
}

bool CAniDoc::loadScene(char *scnname)
{
	FILE *fd=fopen(scnname, "r");
	if (fd==NULL) return false;

	char buf[1024];
	char dllname[128];
	char args[1024];

	Scene *scene = new Scene();

	while (1) {
		if (fgets(buf, 1024, fd)==NULL) break;
		if (buf[0]=='#') continue;	// comment
		strcpy(dllname, strtok(buf, " ,\t\n"));		// model DLL name
		strcpy(args, strtok(NULL, "\n"));			// args

		Object* obj=new Object(dllname, args);
		if (!(obj->isLoaded())) {
			delete obj;
		} else {
			scene->add(obj);
		}
	}

	scene->setDocument(this);
	
	scene->createView();
	scene->createObjList();

	m_pScene = scene;

	return true;
}

void CAniDoc::closeScene()
{
	if (m_pScene)
		delete m_pScene;
	m_pScene=NULL;
}