#include <stdio.h>
#include <stdarg.h>

#include "ctrlPanel.h"
#include "object.h"

#include "Curves.h"

extern Object *objTable[];

ctrlPanel *g_panel;

void curve( int id, char* name, float min, float max, float start )
{
	g_panel->curve(id, name, min, max, start);
	char *buf=new char [64];
	sprintf(buf, "%s#%d@%d", name, g_panel->getObject()->getObjID(), id);
	Curves::getInstance()->addCurve(buf, min, max, start);
}

void scale( int id, char* name, float min, float max, float res, float start )
{
	g_panel->scale(id, name, min, max, res, start);
	char *buf=new char [64];
	sprintf(buf, "%s#%d@%d", name, g_panel->getObject()->getObjID(), id);
	Curves::getInstance()->addCurve(buf, min, max, start);
}

void checkbox( int id, char* name, int state )
{
	g_panel->checkbox(id, name, state);
}

void menu( int id, char* name, int start, char *first, ... )
{
	va_list items;
	char *item;
	int i, count=1; 

    for ( i = 0, va_start( items, first); item = va_arg( items, char* ); ++i )
    {
		++count;
    }
    va_end( items );

	// create the menu
	Fl_Menu_Item *menu=new Fl_Menu_Item[count+1];
	// clear at first
	memset(menu, 0, (count+1)*sizeof(Fl_Menu_Item));

	// the first data
	menu[0].label(first);
	menu[0].shortcut(0);
	menu[0].callback((Fl_Callback*)0);
    for ( i = 1, va_start( items, first ); item = va_arg( items, char* ); ++i )
    {
		// fill in the data
		menu[i].label(item);
		menu[i].shortcut(0);
		menu[i].callback((Fl_Callback*)0);
    }
    va_end( items );
	
	menu[count].label(0);
	menu[count].shortcut(0);
	menu[count].callback((Fl_Callback*)0);

	g_panel->menu(id, name, start, menu );
}

void ptr(int id, void *ptr)
{
	g_panel->ptr(id, ptr);
}

float get_control_f(int obj_id, int ctrl_id)
{
	Object *obj=objTable[obj_id];

	return (float)(obj->getControlValue(ctrl_id));
}

int get_control_i(int obj_id, int ctrl_id)
{
	Object *obj=objTable[obj_id];

	return (int)(obj->getControlValue(ctrl_id));
}

bool get_control_b(int obj_id, int ctrl_id)
{
	Object *obj=objTable[obj_id];

	if (obj->getControlValue(ctrl_id)==0) return false;
	else return true;
}

void *get_ptr(int obj_id, int ctrl_id)
{
	Object *obj=objTable[obj_id];

	return obj->getPtr(ctrl_id);
}