//
// Modeler.h
//

#ifndef __MODELER_H__
#define __MODELER_H__

//
// Definitions for drawmode and drawquality
//
#define MODE_NORMAL			1
#define MODE_WIREFRAME		2
#define MODE_FLATSHADE		4
#define MODE_RAYTRACE		8

#define MODE_HIGH_QUALITY   256
#define MODE_MED_QUALITY    512
#define MODE_LOW_QUALITY    1024

//
// type definitions for functions in model DLL
//
typedef void (* lpSetDrawModeFunc)(int);

typedef bool (* lpInitFunc)(void *);
typedef void (* lpRedrawFunc)(int, int);

typedef void (* lpGetNameFunc)(char*);
typedef void (* lpAssignIDFunc)(int);

// export functions
extern lpSetDrawModeFunc setDrawMode;

// import functions
typedef void (* lpCurveFunc)(int,char*,float,float,float);
typedef void (* lpScaleFunc)(int,char*,float,float,float,float);
typedef void (* lpCheckboxFunc)(int,char*,int);
typedef void (* lpMenuFunc)(int,char*,int,char *, ... );
typedef void (* lpPtrFunc)(int,void*);

typedef float (* lpGetTimeFunc)();
typedef float (* lpGetfFunc)(int,int);
typedef int   (* lpGetiFunc)(int,int);
typedef bool  (* lpGetbFunc)(int,int);
typedef void* (* lpGetPtrFunc)(int,int);

typedef void (* lpPatchControlFunc)(lpCurveFunc, lpScaleFunc, lpCheckboxFunc, lpMenuFunc, 
									lpGetfFunc, lpGetiFunc, lpGetbFunc, lpGetTimeFunc, 
									lpPtrFunc, lpGetPtrFunc );


#endif